/*
Project     : USART0 TEST1
              uart0_rx_01.c
Date        : 2007-02-10
Company     : AvrMall.com
Chip type   : ATmega128-16ai
Clock       : 16.000000 MHz
Comment     : ۽  ,  ͷƮ  PC Ͽ USART0 ͸    ͸ ϴ α׷
              PortB LED   ͹̳â 'a'~'d' Ű带  led .
              'a' portb.0Ʈ, 'b' portb.1Ʈ, 'c' portb.2Ʈ, 'd' portb.3Ʈ   led .
*/

#include <mega128.h>
#include <stdio.h> 
#include <delay.h>

#define UDRE0 5

char flash TITLE_LINE[] = "M128 USART RX0 Test Program AvrMall.com\r";
                                                                        
bit uart_rx_flag=0; 
char rx0_data;


void TxData(char data)
{
        while(!(UCSR0A & (1<<UDRE0)));// UDRE0 CHECK
        UDR0 = data;
}

interrupt [USART0_RXC] void usart0_rx_isr(void)
{
        char status;
        
        status=UCSR0A;
        rx0_data=UDR0;
        
        uart_rx_flag=1;
}

void rx0_led_onoff(void)
{ 
        TxData(rx0_data); //rx0 data echo

        if(rx0_data == 'a'){ //'a'=0x61
                PORTB = ~0x01;
        }
        else if(rx0_data == 'b'){ //'b'=0x62
                PORTB = ~0x02;
        }
        else if(rx0_data == 'c'){ //'b'=0x63
                PORTB = ~0x04;
        }
        else if(rx0_data == 'd'){ //'b'=0x64
                PORTB = ~0x08;
        }    
        else
        {
                PORTB = 0xff; // led all off
        }  
} 


void main(void)
{
        // Port B
        PORTB=0x00;
        DDRB=0x0f; //B port - 4 output

	// USART0 initialization
	// Communication Parameters: 8 Data, 1 Stop, No Parity
	// USART0 Receiver: On
	// USART0 Transmitter: On
	// USART0 Mode: Asynchronous
	// USART0 Baud rate: 9600
	UCSR0A=0x00;
	UCSR0B=0x98;
	UCSR0C=0x06;
	UBRR0H=0x00;
	UBRR0L=0x67;    //16MHz 
	//UBRR0L=0x33;    //8MHz 
	
	#asm("sei")
	
	putsf(TITLE_LINE); 
	printf("Press keyboard 'a'~'d'\n\r");
	
	while(1)
	{
	        if(uart_rx_flag==1)
	        {
	                rx0_led_onoff(); 
	                uart_rx_flag=0;
	        }        
	}
} 