/*
Project     : USART0 TEST1
              uart0_rx_01.c
Date        : 2007-02-10
Company     : AvrMall.com
Chip type   : ATmega128-16ai
Clock       : 16.000000 MHz
Comment     : ۽  ,  ͷƮ  PC Ͽ USART0 ͸    ͸ ϴ α׷
              PortB LED   ͹̳â 'a'~'d' Ű带  led .
              'a' portb.0Ʈ, 'b' portb.1Ʈ, 'c' portb.2Ʈ, 'd' portb.3Ʈ   led .
*/

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega128


#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb RAMPZ=0x3b;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-


// Interrupt vectors definitions


// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-



char flash TITLE_LINE[] = "M128 USART RX0 Test Program AvrMall.com\r";
                                                                        
bit uart_rx_flag=0; 
char rx0_data;


void TxData(char data)
{
        while(!(UCSR0A & (1<<5)));// UDRE0 CHECK
        UDR0 = data;
}

interrupt [19] void usart0_rx_isr(void)
{
        char status;
        
        status=UCSR0A;
        rx0_data=UDR0;
        
        uart_rx_flag=1;
}

void rx0_led_onoff(void)
{ 
        TxData(rx0_data); //rx0 data echo

        if(rx0_data == 'a'){ //'a'=0x61
                PORTB = ~0x01;
        }
        else if(rx0_data == 'b'){ //'b'=0x62
                PORTB = ~0x02;
        }
        else if(rx0_data == 'c'){ //'b'=0x63
                PORTB = ~0x04;
        }
        else if(rx0_data == 'd'){ //'b'=0x64
                PORTB = ~0x08;
        }    
        else
        {
                PORTB = 0xff; // led all off
        }  
} 


void main(void)
{
        // Port B
        PORTB=0x00;
        DDRB=0x0f; //B port - 4 output

	// USART0 initialization
	// Communication Parameters: 8 Data, 1 Stop, No Parity
	// USART0 Receiver: On
	// USART0 Transmitter: On
	// USART0 Mode: Asynchronous
	// USART0 Baud rate: 9600
	UCSR0A=0x00;
	UCSR0B=0x98;
	(*(unsigned char *) 0x95)=0x06;
	(*(unsigned char *) 0x90)=0x00;
	UBRR0L=0x67;    //16MHz 
	//UBRR0L=0x33;    //8MHz 
	
	#asm("sei")
	
	putsf(TITLE_LINE); 
	printf("Press keyboard 'a'~'d'\n\r");
	
	while(1)
	{
	        if(uart_rx_flag==1)
	        {
	                rx0_led_onoff(); 
	                uart_rx_flag=0;
	        }        
	}
} 
